#include <jni.h>
#include <android/bitmap.h>
#include <android/log.h>

#define  LOG_TAG    "BitmapNDK"
#define  LOGE(...)  __android_log_print(ANDROID_LOG_ERROR,LOG_TAG,__VA_ARGS__)

void Java_com_adamrocker_android_bitmapndk_BitmapNdkActivity_effectNative(JNIEnv * env, jobject thiz, jobject bitmap)
{
    AndroidBitmapInfo  info;
    void*              pixs;
    int                ret;

    //Bitmapの情報を取得
    if ((ret = AndroidBitmap_getInfo(env, bitmap, &info)) < 0) {
        LOGE("AndroidBitmap_getInfo() failed ! error=%d", ret);
        return;
    }

    //Bitmapの画素配列を取得
    if ((ret = AndroidBitmap_lockPixels(env, bitmap, &pixs)) < 0) {
        LOGE("AndroidBitmap_lockPixels() failed ! error=%d", ret);
        return;
    }
	uint32_t* pixels = (uint32_t*)pixs;
	int y,x;
	for (y = 0; y < info.height; y++) {
		int line = y * info.width;;
		for (x = 0; x < info.width; x++) {
	        int index = line + x;
            uint32_t color = pixels[index];
  	        int r = (color & 0x00ff0000) >> 16;
            int g = (color & 0x0000ff00) >> 8;
            int b = (color & 0x000000ff);
            //NTSC加重平均によるグレースケール値
            double gray = 0.298912 * r + 0.586611 * g + 0.114478 * b;
            r = (int) (255.0 - gray);
            g = r;
            b = g;
            pixels[index] = 0xff000000 | (r << 16) | (g << 8) | b;
		}
	}
    AndroidBitmap_unlockPixels(env, bitmap);
}